aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorKevin Wolf <kwolf@redhat.com>2009-07-03 17:45:56 +0200
committerChristoph Hellwig <hch@lst.de>2009-07-03 17:45:56 +0200
commit97309da98216c753db1512cffbd16ab8964ac252 (patch)
treeaf3ee16bb082c4e25d1356aa5eed3919ec37f0f9
parent8b9a81d9670936382cd8eb2a4b2c9b61acc25be2 (diff)
downloadqemu-iotests-97309da98216c753db1512cffbd16ab8964ac252.tar.gz
add test for refcount table growth and snapshots
015: Combined test to grow the refcount table and test snapshots. Signed-off-by: Kevin Wolf <kwolf@redhat.com> Signed-off-by: Christoph Hellwig <hch@lst.de>
-rwxr-xr-x01585
-rw-r--r--015.out20
-rw-r--r--group1
3 files changed, 106 insertions, 0 deletions
diff --git a/015 b/015
new file mode 100755
index 0000000..ad8a3d0
--- /dev/null
+++ b/015
@@ -0,0 +1,85 @@
+#!/bin/sh
+#
+# Combined test to grow the refcount table and test snapshots.
+#
+# Copyright (C) 2009 Red Hat, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
+# USA
+#
+
+# creator
+owner=kwolf@redhat.com
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+
+_cleanup()
+{
+# _cleanup_test_img
+ true
+}
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# currently only qcow2 allows for consistency checks using qemu-img
+_supported_fmt qcow2
+_supported_os Linux
+
+echo
+echo "creating image"
+
+# With 1k clusters a refcount block contains 512 clusters
+# This makes 512k of the image file covered by a refcount block
+# A refcount table that spans one clusters has 128 refcount
+# tables which makes up 64M in the image file.
+#
+# We use a 36M image, so initially we can be sure that only one cluster is used
+# for the refcount table. On the other hand this is big enough to cause a
+# refcount table growth when rewriting the image after creating one snapshot.
+size=36M
+_make_test_img -o cluster_size=1k $size
+
+# Create two snapshots which fill the image with two different patterns
+echo "creating first snapshot"
+$QEMU_IO -c "aio_write -P 123 0 $size" $TEST_IMG | _filter_qemu_io
+$QEMU_IMG snapshot -c snap1 $TEST_IMG
+echo "creating second snapshot"
+$QEMU_IO -c "aio_write -P 165 0 $size" $TEST_IMG | _filter_qemu_io
+$QEMU_IMG snapshot -c snap2 $TEST_IMG
+
+# Now check the pattern
+echo "checking first snapshot"
+$QEMU_IMG snapshot -a snap1 $TEST_IMG
+$QEMU_IO -c "aio_read -P 123 0 $size" $TEST_IMG | _filter_qemu_io
+echo "checking second snapshot"
+$QEMU_IMG snapshot -a snap2 $TEST_IMG
+$QEMU_IO -c "aio_read -P 165 0 $size" $TEST_IMG | _filter_qemu_io
+
+echo
+echo "checking image for errors"
+_check_test_img
+
+# success, all done
+echo "*** done"
+rm -f $seq.full
+status=0
diff --git a/015.out b/015.out
new file mode 100644
index 0000000..3ba723d
--- /dev/null
+++ b/015.out
@@ -0,0 +1,20 @@
+QA output created by 015
+
+creating image
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=37748736 cluster_size=1024
+creating first snapshot
+wrote 37748736/37748736 bytes at offset 0
+36 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+creating second snapshot
+wrote 37748736/37748736 bytes at offset 0
+36 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+checking first snapshot
+read 37748736/37748736 bytes at offset 0
+36 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+checking second snapshot
+read 37748736/37748736 bytes at offset 0
+36 MiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+
+checking image for errors
+No errors were found on the image.
+*** done
diff --git a/group b/group
index 155e1ce..3beb952 100644
--- a/group
+++ b/group
@@ -21,3 +21,4 @@
012 auto
013 rw auto
014 rw auto
+015 rw snapshot auto